# v3.8.0

## Summary

The v3.8.0 release includes features and fixes from 33 pull requests since v3.7.0.  While summer vacations have slowed the pace of development a bit this month, there are some nice improvements in this release.  See the complete list below for details.

## New features and fixes

 * [#3957](https://github.com/openlayers/openlayers/pull/3957) - Properly handle vertex deletion with multiple features. ([@tschaub](https://github.com/tschaub))
 * [#3954](https://github.com/openlayers/openlayers/pull/3954) - Remove ol.control.Control.bindMouseOutFocusOutBlur function. ([@fredj](https://github.com/fredj))
 * [#3214](https://github.com/openlayers/openlayers/pull/3214) - Pixel manipulation with raster sources. ([@tschaub](https://github.com/tschaub))
 * [#3946](https://github.com/openlayers/openlayers/pull/3946) - Fix vertex deletion for Modify interaction on mobile devices. ([@Turbo87](https://github.com/Turbo87))
 * [#3910](https://github.com/openlayers/openlayers/pull/3910) - Do not provide an AMD environment to ol.ext modules. ([@ahocevar](https://github.com/ahocevar))
 * [#3934](https://github.com/openlayers/openlayers/pull/3934) - Fix `drawstart` and `drawend` events when drawing a point ([@fredj](https://github.com/fredj))
 * [#3774](https://github.com/openlayers/openlayers/pull/3774) - Measure tooltips touchdevice ([@pgiraud](https://github.com/pgiraud))
 * [#3949](https://github.com/openlayers/openlayers/pull/3949) - Remove count argument from `called` function ([@fredj](https://github.com/fredj))
 * [#3950](https://github.com/openlayers/openlayers/pull/3950) - Remove reference to vbarray.js ([@elemoine](https://github.com/elemoine))
 * [#3947](https://github.com/openlayers/openlayers/pull/3947) - Clarify documentation of Image source ratio option. ([@alvinlindstam](https://github.com/alvinlindstam))
 * [#3920](https://github.com/openlayers/openlayers/pull/3920) - Remove use_types_for_optimization from custom build tutorial. ([@probins](https://github.com/probins))
 * [#3922](https://github.com/openlayers/openlayers/pull/3922) - Document {?-?} pattern in expandUrl ([@probins](https://github.com/probins))
 * [#3921](https://github.com/openlayers/openlayers/pull/3921) - Cache node_modules on Travis. ([@bjornharrtell](https://github.com/bjornharrtell))
 * [#3942](https://github.com/openlayers/openlayers/pull/3942) - Fix WMTS TileMatrixSet lookup by SRS identifier ([@ahocevar](https://github.com/ahocevar))
 * [#3945](https://github.com/openlayers/openlayers/pull/3945) - Simplify icon example and show popup at clicked position ([@ahocevar](https://github.com/ahocevar))
 * [#3930](https://github.com/openlayers/openlayers/pull/3930) - Use goog.functions.identity instead of goog.identityFunction ([@fredj](https://github.com/fredj))
 * [#3929](https://github.com/openlayers/openlayers/pull/3929) - Expand description for XYZ source ([@probins](https://github.com/probins))
 * [#3933](https://github.com/openlayers/openlayers/pull/3933) - Snap center to pixel to avoid floating point issues ([@ahocevar](https://github.com/ahocevar))
 * [#3932](https://github.com/openlayers/openlayers/pull/3932) - SnapOptions: Fix typo in pixelTolerance JSDoc ([@Turbo87](https://github.com/Turbo87))
 * [#3931](https://github.com/openlayers/openlayers/pull/3931) - Remove unused htmlparser2 package ([@fredj](https://github.com/fredj))
 * [#3912](https://github.com/openlayers/openlayers/pull/3912) - Fix the event type fired by goog.fx.Dragger ([@fredj](https://github.com/fredj))
 * [#3871](https://github.com/openlayers/openlayers/pull/3871) - Document change events properly ([@ahocevar](https://github.com/ahocevar))
 * [#3906](https://github.com/openlayers/openlayers/pull/3906) - Clear features properly when there is no spatial index ([@ahocevar](https://github.com/ahocevar))
 * [#3896](https://github.com/openlayers/openlayers/pull/3896) - Fire WebGL precompose event in same sequence as other renderers ([@ahocevar](https://github.com/ahocevar))
 * [#3359](https://github.com/openlayers/openlayers/pull/3359) - Enable deep clone of MultiPolygon. ([@Kenny806](https://github.com/Kenny806))
 * [#3895](https://github.com/openlayers/openlayers/pull/3895) - Rework the tile queue for multiple queues. ([@aisaacs](https://github.com/aisaacs))
 * [#3894](https://github.com/openlayers/openlayers/pull/3894) - Install Python dependencies without sudo. ([@tschaub](https://github.com/tschaub))
 * [#3824](https://github.com/openlayers/openlayers/pull/3824) - Improve docs for interaction.Select. ([@probins](https://github.com/probins))
 * [#3884](https://github.com/openlayers/openlayers/pull/3884) - Provide a debug loader for the library. ([@tschaub](https://github.com/tschaub))
 * [#3883](https://github.com/openlayers/openlayers/pull/3883) - Ignore layer filter for unmanaged layers ([@ahocevar](https://github.com/ahocevar))
 * [#3859](https://github.com/openlayers/openlayers/pull/3859) - Add in crossOrigin option ([@llambanna](https://github.com/llambanna))
 * [#3873](https://github.com/openlayers/openlayers/pull/3873) - Correct minor typo in modifyinteraction ([@probins](https://github.com/probins))
 * [#3872](https://github.com/openlayers/openlayers/pull/3872) - Correct event notations in ol.Feature ([@probins](https://github.com/probins))
